Subject: [Sigtran] Re: Query Regarding M2PA Rfc 4165

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 21 Oct 2005 14:57:53 -0600

Amit,

Amit Ray wrote:                                                                       (Fri, 21 Oct 2005 20:46:10)
> 
> Hi Brian,
>        I'd like some clarification on the Processor Outage mechanism
> defined in RFC 4165.
> 
>   What should be the behavior in the following scenario:
> 
> 1. Let us suppose there are two sides A and B. A and B both are in LPO
> condition. Hence both the sides are in LPO and RPO simultaneously.
> 2. Now LPO ends at side A. It will send a LPO Ended message to peer.
> 3. Now what should be the behavior at side B? As it is still in LPO, should
> not send a LS Ready message because it has some buffered data which is
> still not  notified to the application(as per the buffering mechanism in
> LPO) . Hence correct re synchronization of FSN and BSN is not possible at
> this moment.

Why not?  B can send LS Ready.

Then I suppose there is no problem.

--brian

> 4. RFC 4165 says that if one end is in RPO, it should continue sending user
> data  messages and other end should buffer it. It also says that  "M2PA
> SHALL NOT resume   transmitting User Data messages until it has sent the
> Link Status  Ready message".
> 5. Hence in this case neither A nor B can send a packet as neither end
> sends a  LS Ready message. But as A is in RPO, it can continues sending
> and receiving  user data messages and B should buffer  it.
> 

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

_______________________________________________
Sigtran mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/sigtran

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Sat, 22 Oct 2005 03:59:19 -0600

Amit,

How can one side buffer data in LPO and RPO.  I don't think that it can.
The other side cannot send messages in this state and the near side cannot
acknowledge them in this state.

If you think this can occur, you need to detail the events leading up to
and after both LPO and RPO in your example.

--brian

Amit Ray wrote:                                                                       (Sat, 22 Oct 2005 11:42:10)
> 
> 
> 
> 
> Brian,
>             I guess there will be one problem.
> Let us suppose, in continuation with my example: At the moment when B has
> received a LPO Ended message from A, it has four data buffered in the queue
> with FSN=4,5,6,7. Now In LS Ready message it will send BSN=3 because those
> buffered data is still not processed(and delivered to
> application,Application is in LPO).After receiving LS ready message from B,
> A will re synchronize itself and start sending next data starting with
> FSN=4. Now suddenly LPO ended at side B. It now process all the buffered
> data and send LPO Ended with BSN=7. A has send last data with FSN=4 but in
> LPO Ended it has got acknowledgement for message with BSN=7.
> Another problem is that, if LPO is not ended at side B, then it will still
> keep buffering data. Hence A starts sending data with FSN=4, but at side B,
> it already has data buffered with FSN=4.
> 
> Rgds
> Amit
> 

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Sat, 22 Oct 2005 04:28:55 -0600

Amit,

Amit Ray wrote:                                                                       (Sat, 22 Oct 2005 12:07:58)
> 
> 
> 
> 
> Brian,
>             One more update. I think Ready message can be sent from Side B
> but with the last FSN as BSN that is buffered in the local queue i.e from B
> send ready message with BSN= 7  (last data buffered at B's Queue) .I think
> that might solve the problem.
> 

I think that you need to consider the interaction between MTP2 and
MTP3: if the side recovering from LPO receives a flush from MTP3
then it needs to resyncrhonize sequence numbers.  If it just receives
a Continue, then it does not need to resynchronize sequence numbers.
Also, because RPO remains, the link remains blocked and messages will
not be sent.  Therefore it makes little difference what sequence number
the side in RPO assigns to outgoing messages, as it cannot send any.
Another resynchronization will occur when the RPO condition is cleared.
The remote side will either flush them or deliver them.

See the example on Page 40.

If you still think that there is a problem, please draw out all of the
actions taken by MTP3 and MTP2 on both sides of the link from in-service
state through RPO, LPO and back to in-service state.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/